"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createApp = void 0;
var tslib_1 = require("tslib");
var vue_1 = require("vue");
var vue_router_1 = require("vue-router");
var core_1 = require("@leanjs/core");
var mountApp = core_1._.mountApp, getDefaultPathname = core_1._.getDefaultPathname, dedupeSlash = core_1._.dedupeSlash, createAppError = core_1._.createAppError, setRuntimeContext = core_1._.setRuntimeContext;
var createApp = function (App, _a) {
    var appName = _a.appName, _b = _a.router, _c = _b === void 0 ? {} : _b, _d = _c.routes, routes = _d === void 0 ? [] : _d, routerConfig = tslib_1.__rest(_c, ["routes"]);
    if (!appName)
        throw new Error("appName required in Vue createApp");
    var createComposableApp = function (_a) {
        var _b = _a === void 0 ? {} : _a, isSelfHosted = _b.isSelfHosted, version = _b.version;
        var mount = function (el, _a) {
            var runtime = _a.runtime, onRemoteNavigate = _a.onRemoteNavigate, basename = _a.basename, _b = _a.pathname, pathname = _b === void 0 ? getDefaultPathname(isSelfHosted) : _b, onError = _a.onError, rest = tslib_1.__rest(_a, ["runtime", "onRemoteNavigate", "basename", "pathname", "onError"]);
            var app;
            var semaphore = true;
            var history = isSelfHosted
                ? (0, vue_router_1.createWebHistory)(basename)
                : (0, vue_router_1.createMemoryHistory)(basename);
            history.replace(pathname);
            var router = (0, vue_router_1.createRouter)(tslib_1.__assign({ history: history, routes: routes }, routerConfig));
            return {
                unmount: mountApp(tslib_1.__assign(tslib_1.__assign({}, rest), { el: el, appName: appName, isSelfHosted: isSelfHosted, onError: onError, cleanups: onRemoteNavigate
                        ? [
                            router.beforeEach(function (to, from) {
                                if (from !== vue_router_1.START_LOCATION) {
                                    // check if the next path (to.path) is inside the mfe (in its routes)
                                    var isToAppRoute = routes.find(function (_a) {
                                        var path = _a.path;
                                        return path.replace(/\/$/, "") === to.path.replace(/\/$/, "");
                                    });
                                    var nextPathname = isToAppRoute
                                        ? dedupeSlash([basename, to.path].join("/"))
                                        : to.path;
                                    onRemoteNavigate === null || onRemoteNavigate === void 0 ? void 0 : onRemoteNavigate({
                                        pathname: nextPathname,
                                        hash: to.hash,
                                        // TODO search: to.query,
                                    });
                                }
                            }),
                        ]
                        : [], render: function (_a) {
                        var appProps = _a.appProps, rendered = _a.rendered;
                        try {
                            app = (0, vue_1.createApp)(App, tslib_1.__assign(tslib_1.__assign({}, appProps), { isSelfHosted: isSelfHosted }))
                                .provide("runtime", setRuntimeContext({ appName: appName, version: version }, runtime))
                                .use(router);
                            app.mount(el);
                            rendered(); // TODO done when onMounted
                        }
                        catch (error) {
                            throw createAppError({ appName: appName, version: version, error: error });
                        }
                    }, unmount: function () {
                        app === null || app === void 0 ? void 0 : app.unmount();
                    } })),
                onHostNavigate: function (_a) {
                    var rawNextPathname = _a.pathname;
                    return tslib_1.__awaiter(void 0, void 0, void 0, function () {
                        var nextPathname;
                        return tslib_1.__generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    nextPathname = dedupeSlash((rawNextPathname + "/").replace(basename + "/", "/"));
                                    if (!(semaphore && nextPathname !== history.location)) return [3 /*break*/, 2];
                                    semaphore = false;
                                    // We need a semaphore here because VueRouter router.push is async.
                                    // router.push triggers an event in the router of the host because of onRemoteNavigate,
                                    // which triggers onHostNavigate again. However, history.location is not yet updated this second time because router.push is async.
                                    // That creates an infinite loop. This semaphore avoids such infinite loop.
                                    return [4 /*yield*/, (router === null || router === void 0 ? void 0 : router.push(nextPathname))];
                                case 1:
                                    // We need a semaphore here because VueRouter router.push is async.
                                    // router.push triggers an event in the router of the host because of onRemoteNavigate,
                                    // which triggers onHostNavigate again. However, history.location is not yet updated this second time because router.push is async.
                                    // That creates an infinite loop. This semaphore avoids such infinite loop.
                                    _b.sent();
                                    semaphore = true;
                                    _b.label = 2;
                                case 2: return [2 /*return*/];
                            }
                        });
                    });
                },
            };
        };
        return { mount: mount, appName: appName, version: version };
    };
    createComposableApp.appName = appName;
    return createComposableApp;
};
exports.createApp = createApp;
